10     DIM Pri$[9],Sec$[9],Mode$[9],Aux$[9],Meas_time$[9],Low_c_rej$[9]
20     REAL Freq,Lvl,Nom,Low_c_rej_lim
30     REAL L_lim(1:3),U_lim(1:3),L_lim_sec,U_lim_sec,Pri_res,Sec_res
40     INTEGER Max_meas,Cbl,Result,Meas_stat,Comp,Bin(1:11),Ovld,I
50     CLEAR SCREEN
60     !
70     ASSIGN @Agt4288a TO 717
80     !
90     Max_meas=10
100    !
110    Pri$="CP"
120    Sec$="D"
130    Freq=1.E+3
140    Lvl=1.0
150    Meas_time$="SHOR"
160    Cbl=1
170    !
180    Mode$="PCNT"
190    Nom=1.E-9
200    !-- [BIN1] --
210    L_lim(1)=-1.0
220    U_lim(1)=1.0
230    !-- [BIN2] --
240    L_lim(2)=-2.0
250    U_lim(2)=2.0
260    !-- [BIN3] --
270    L_lim(3)=-3.0
280    U_lim(3)=3.0
290    !-- [Sec] --
300    L_lim_sec=0.
310    U_lim_sec=.1
320    Aux$="ON"
330    Low_c_rej$="ON"
340    Low_c_rej_lim=10.0
350    !
360    OUTPUT @Agt4288a;"*RST"
370    OUTPUT @Agt4288a;":CALC1:FORM ";Pri$
380    OUTPUT @Agt4288a;":CALC2:FORM ";Sec$
390    OUTPUT @Agt4288a;":SOUR:FREQ ";Freq
400    OUTPUT @Agt4288a;":SOUR:VOLT ";Lvl
410    OUTPUT @Agt4288a;":APER "&Meas_time$
420    OUTPUT @Agt4288a;":CAL:CABL ";Cbl
430    !
440    OUTPUT @Agt4288a;":DISP OFF"
450    OUTPUT @Agt4288a;":SYST:BEEP:STAT OFF"
460    OUTPUT @Agt4288a;":SYST:KLOC ON"
470    !
480    ! Compensation
490    !
500    Result=FNCompen(@Agt4288a,"Open",.00002)
510    IF Result<>0 THEN Prog_end
520    Result=FNCompen(@Agt4288a,"Short",20)
530    IF Result<>0 THEN Prog_end
540    Result=FNCompen(@Agt4288a,"Load",20)
550    IF Result<>0 THEN Prog_end
560    !
570    OUTPUT @Agt4288a;":RANG ";Nom
580    !
590    ! Comparator Setting
600    !
610    OUTPUT @Agt4288a;":CALC:COMP:MODE "&Mode$
620    OUTPUT @Agt4288a;":CALC:COMP:PRIM:NOM ";Nom
630    FOR I=1 TO 3
640      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&" ";L_lim(I);",";U_lim(I)
650      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT ON"
660    NEXT I
670    FOR I=4 TO 9
680      OUTPUT @Agt4288a;":CALC:COMP:PRIM:BIN"&VAL$(I)&":STAT OFF"
690    NEXT I
700    OUTPUT @Agt4288a;":CALC:COMP:SEC:LIM ";L_lim_sec;",";U_lim_sec
710    OUTPUT @Agt4288a;":CALC:COMP:SEC:STAT ON"
720    !
730    OUTPUT @Agt4288a;":CALC:COMP:AUXB ON"
740    OUTPUT @Agt4288a;":CREJ "&Low_c_rej$
750    OUTPUT @Agt4288a;":CREJ:LIM ";Low_c_rej_lim
760    OUTPUT @Agt4288a;":CALC:COMP ON"
770    !
780    ! Trigger setting
790    !
800    OUTPUT @Agt4288a;":TRIG:SOUR EXT"
810    OUTPUT @Agt4288a;":INIT:CONT ON"
820    !
830    ! Bin count setting
840    !
850    OUTPUT @Agt4288a;":CALC:COMP:COUN ON"
860    OUTPUT @Agt4288a;":CALC:COMP:COUN:CLE"
870    OUTPUT @Agt4288a;"*OPC?"
880    ENTER @Agt4288a;Buff$
890    !
900    ! SRQ setting
910    !
920    OUTPUT @Agt4288a;":STAT:OPER:ENAB 16"
930    OUTPUT @Agt4288a;"*SRE 128"
940    !
950    FOR I=1 TO Max_meas
960      REPEAT
970        OUTPUT @Agt4288a;":STAT:OPER:COND?"
980        ENTER @Agt4288a;Cond_reg
990      UNTIL BIT(Cond_reg,5)
1000     OUTPUT @Agt4288a;"*CLS"
1010     OUTPUT @Agt4288a;"*OPC?"
1020     ENTER @Agt4288a;Buff$
1030     ON INTR 7 GOTO Meas_end
1040     ENABLE INTR 7;2
1050     PRINT "Set DUT, then input external trigger!"
1060 Meas_wait: GOTO Meas_wait
1070 Meas_end: OFF INTR 7
1080     OUTPUT @Agt4288a;":FETC?"
1090     ENTER @Agt4288a;Meas_stat,Pri_res,Sec_res,Comp
1100     !
1110     PRINT "[MEASUREMENT RESULT]"
1120     PRINT USING "X,7A,X,2D";"BIN   :",Comp
1130     PRINT USING "X,7A,X,2D";"STATUS:",Meas_stat
1140     PRINT USING "X,6A,A,X,SD.5DE";Pri$,":",Pri_res
1150     PRINT USING "X,6A,A,X,SD.5DE";Sec$,":",Sec_res
1160   NEXT I
1170   !
1180   OUTPUT @Agt4288a;":CALC:COMP:COUN:DATA?"
1190   ENTER @Agt4288a;Bin(*)
1200   OUTPUT @Agt4288a;":CALC:COMP:COUN:OVLD?"
1210   ENTER @Agt4288a;Ovld
1220   PRINT "[BIN COUNT RESULT]"
1230   PRINT "   BIN             Count"
1240   PRINT " ------------------------"
1250   FOR I=1 TO 3
1260     PRINT USING "2X,17A,5D";"BIN"&VAL$(I)&":",Bin(I)
1270   NEXT I
1280   PRINT USING "2X,17A,5D";"OUT OF BINS:",Bin(10)
1290   PRINT USING "2X,17A,5D";"AUX BIN:",Bin(11)
1300   PRINT USING "2X,17A,5D";"OVLD:",Ovld
1310   !
1320 Prog_end: END
1330   !=============================================
1340   ! Compensation Data Measurement Function
1350   !=============================================
1360 DEF FNCompen(@Agt4288a,Standard$,Limit)
1370   DIM Inp_char$[9],Buff$[9],Std$[9],Err$[50]
1380   REAL Curr_freq,Freq(1:2),Para1,Para2,Zm,Ym,Gm,Bm
1390   REAL Cpref,Dref,Zref,Gref,Bref
1400   INTEGER Err_flag
1410   OUTPUT @Agt4288a;":SOUR:FREQ?"
1420   ENTER @Agt4288a;Curr_freq
1430   Freq(1)=1.E+3
1440   Freq(2)=1.E+6
1450   Load_para$="CPD"
1460   OUTPUT @Agt4288a;":STAT:OPER:ENAB 128"
1470   OUTPUT @Agt4288a;"*SRE 128"
1480   SELECT Standard$
1490     CASE "Open"
1500       Std$="STAN1"
1510     CASE "Short"
1520       Std$="STAN2"
1530     CASE "Load"
1540       Std$="STAN3"
1550       CALL Inp_data("Load(Cp) Value @1kHz",Load1(1))
1560       CALL Inp_data("Load(D)  Value @1kHz",Load2(1))
1570       CALL Inp_data("Load(Cp) Value @1MHz",Load1(2))
1580       CALL Inp_data("Load(D)  Value @1MHz",Load2(2))
1590       OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM "&Load_para$
1600       FOR I=1 TO 2
1610         OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
1620         OUTPUT @Agt4288a;":CORR:CKIT:STAN3 ";Load1(I);",";Load2(I)
1630       NEXT I
1640   END SELECT
1650 Compen_meas: !
1660   PRINT "Set "&Standard$&"-Connection."
1670   INPUT "OK? [Y/N]",Inp_char$
1680   IF UPC$(Inp_char$)="Y" THEN 
1690     FOR I=1 TO 2
1700       PRINT "Frequency:";Freq(I)
1710       OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
1720       OUTPUT @Agt4288a;"*CLS"
1730       OUTPUT @Agt4288a;"*OPC?"
1740       ENTER @Agt4288a;Buff$
1750       ! Measurement
1760       ON INTR 7 GOTO Meas_end
1770       ENABLE INTR 7;2
1780       OUTPUT @Agt4288a;":CORR:COLL "&Std$
1790 Meas_wait: GOTO Meas_wait
1800 Meas_end: OFF INTR 7
1810       ! Error Check
1820       OUTPUT @Agt4288a;":SYST:ERR?"
1830       ENTER @Agt4288a;Err_no,Err$
1840       IF Err_no<>0 THEN 
1850         PRINT "Error: "&Err$
1860         GOTO Compen_meas
1870       END IF
1880       ! Data Check
1890       OUTPUT @Agt4288a;":CORR:DATA? "&Std$
1900       ENTER @Agt4288a;Para1,Para2
1910       Err_flag=0
1920       SELECT Standard$
1930         CASE "Open"
1940           Ym=SQRT(Para1*Para1+Para2*Para2)
1950           PRINT "G =";Para1,"B =";Para2,"|Y| =";Ym
1960           IF Ym>=Limit THEN Err_flag=1
1970         CASE "Short"
1980           Zm=SQRT(Para1*Para1+Para2*Para2)
1990           PRINT "R =";Para1,"X =";Para2,"|Z| =";Zm
2000           IF Zm>=Limit THEN Err_flag=1
2010         CASE "Load"
2020           OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
2030           ENTER @Agt4288a;Cpref,Dref
2040           Bref=2*PI*Freq(I)*Cpref
2050           Gref=Bref*Dref
2060           Zref=1/SQRT(Gref*Gref+Bref*Bref)
2070           Bm=2*PI*Freq(I)*Para1
2080           Gm=Bm*Para2
2090           Zm=1/SQRT(Gm*Gm+Bm*Bm)
2100           PRINT "Cpref=";Cpref,"Dref=";Dref,"|Zref| =";Zref
2110           PRINT "Cp   =";Para1,"D   =";Para2,"|Z|    =";Zm
2120           IF ABS((Zm-Zref)/Zref)>=Limit THEN Err_flag=1
2130       END SELECT
2140       IF Err_flag<>0 THEN 
2150         PRINT "Out of limit!!"
2160         GOTO Compen_meas
2170       END IF
2180     NEXT I
2190     PRINT Standard$&" Data Measurement Complete"
2200     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
2210     RETURN 0
2220   ELSE
2230     PRINT "Program Interruption"
2240     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
2250     RETURN -1
2260   END IF
2270 FNEND
2280   !=============================================
2290   ! Data Input Function
2300   !=============================================
2310 SUB Inp_data(Mes$,Inp_val)
2320   DIM Inp_char$[30]
2330   ON ERROR GOTO Inp_start
2340 Inp_start:!
2350   PRINT "Input "&Mes$
2360   INPUT "Value?",Inp_char$
2370   Inp_val=VAL(UPC$(Inp_char$))
2380   PRINT "Input Value: ";Inp_val
2390   INPUT "OK? [Y/N]",Inp_char$
2400   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
2410   OFF ERROR 
2420 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: meas_sys.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
